package listenechoservice;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceListener;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

import provideservice.service.EchoService;

public class UseEchoService implements BundleActivator, Runnable, ServiceListener {
  Thread t;
  boolean cont;
  provideservice.service.EchoService callEcho=null;
  BundleContext bc;
  
  public void start(BundleContext bc) throws Exception {
    this.cont =true;
    this.callEcho=null;
    t=new Thread(this);
    ServiceReference sr=bc.getServiceReference("provideservice.service.EchoService");
    if (sr!=null){
      this.callEcho=(provideservice.service.EchoService)bc.getService(sr);
    }
    this.bc=bc;
    bc.addServiceListener(this, "(objectClass=provideservice.service.EchoService)");
    t.start();
  }

  public void run(){
    while(this.cont){
      if (callEcho !=null){
        System.out.println(callEcho.echo("coucou 2"));
      }else{
        System.out.println("Attention le service est absent");
      }
      try{
      Thread.currentThread().sleep(100);
      }catch (Exception e){}
    }
  }


  public void stop(BundleContext bc){
    this.cont=false;
    this.bc=null;
    this.t=null;
    this.callEcho=null;
    System.out.println("Au revoir");
  }

  public void serviceChanged(ServiceEvent serviceevent){
    switch (serviceevent.getType()){
      case ServiceEvent.REGISTERED:
        ServiceReference sr = serviceevent.getServiceReference();
        this.callEcho=(provideservice.service.EchoService)this.bc.getService(sr);
        break;
      case ServiceEvent.UNREGISTERING:
        this.callEcho=null;
        break;
    }
  }
}
  
