package useurlservice;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

import org.ungoverned.oscar.bundle.url.URLService;

public class UseURLService implements BundleActivator {
  public void start(BundleContext bc) throws Exception {
    ServiceReference sr=bc.getServiceReference("org.ungoverned.oscar.bundle.url.URLService");
    if (sr!=null){
      org.ungoverned.oscar.bundle.url.URLService urls=(org.ungoverned.oscar.bundle.url.URLService)bc.getService(sr);
      if (urls !=null){
        BufferedReader br=new BufferedReader(new InputStreamReader(urls.getURLInputStream(new URL("http://telecom.insa-lyon.fr"))));
        String t=br.readLine();
        while (t!=null){
          System.out.println(">> "+t.toString());
          t=br.readLine();
        }
      }else{
        System.out.println("Erreur, Impossible d'obtenir l'implantation");
      }
    }else{
      System.out.println("Erreur, impossible d'obtenir le service");
    }
  }


  public void stop(BundleContext bc){
    System.out.println("Au revoir");
  }
}
  
